"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _debug = _interopRequireDefault(require("debug"));

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["", ".", " = ", ""]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["default values"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["(", ") values(", ")"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["insert into ", " ", " returning ", ""], ["\\\ninsert into ", " ", " returning ", ""]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var debug = (0, _debug["default"])('graphile-build-pg');

var PgMutationCreatePlugin = function PgMutationCreatePlugin(builder) {
  builder.hook('GraphQLObjectType:fields', function (fields, build, context) {
    var extend = build.extend,
        newWithHooks = build.newWithHooks,
        parseResolveInfo = build.parseResolveInfo,
        pgIntrospectionResultsByKind = build.pgIntrospectionResultsByKind,
        pgGetGqlTypeByTypeIdAndModifier = build.pgGetGqlTypeByTypeIdAndModifier,
        pgGetGqlInputTypeByTypeIdAndModifier = build.pgGetGqlInputTypeByTypeIdAndModifier,
        sql = build.pgSql,
        gql2pg = build.gql2pg,
        _build$graphql = build.graphql,
        GraphQLObjectType = _build$graphql.GraphQLObjectType,
        GraphQLInputObjectType = _build$graphql.GraphQLInputObjectType,
        GraphQLNonNull = _build$graphql.GraphQLNonNull,
        GraphQLString = _build$graphql.GraphQLString,
        pgColumnFilter = build.pgColumnFilter,
        inflection = build.inflection,
        queryFromResolveData = build.pgQueryFromResolveData,
        omit = build.pgOmit,
        viaTemporaryTable = build.pgViaTemporaryTable,
        describePgEntity = build.describePgEntity,
        sqlCommentByAddingTags = build.sqlCommentByAddingTags,
        pgField = build.pgField,
        pgPrepareAndRun = build.pgPrepareAndRun;
    var isRootMutation = context.scope.isRootMutation,
        fieldWithHooks = context.fieldWithHooks;

    if (!isRootMutation) {
      return fields;
    }

    return extend(fields, pgIntrospectionResultsByKind["class"].reduce(function (memo, table) {
      // PERFORMANCE: These used to be .filter(...) calls
      if (!table.namespace) return memo;
      if (!table.isSelectable) return memo;
      if (!table.isInsertable || omit(table, 'create')) return memo;
      var primaryKeyConstraint = table.primaryKeyConstraint;
      if (!primaryKeyConstraint) return memo;
      var keyColumns = primaryKeyConstraint.keyAttributes;
      var Table = pgGetGqlTypeByTypeIdAndModifier(table.type.id, null);

      if (!Table) {
        debug("There was no table type for table '".concat(table.namespace.name, ".").concat(table.name, "', so we're not generating a create mutation for it."));
        return memo;
      }

      var TableInput = pgGetGqlInputTypeByTypeIdAndModifier(table.type.id, null);

      if (!TableInput) {
        debug("There was no input type for table '".concat(table.namespace.name, ".").concat(table.name, "', so we're going to omit it from the create mutation."));
      }

      var tableTypeName = inflection.tableType(table);
      var InputType = newWithHooks(GraphQLInputObjectType, {
        name: inflection.createInputType(table),
        description: "All input for the create `".concat(tableTypeName, "` mutation."),
        fields: _objectSpread({
          clientMutationId: {
            description: 'An arbitrary string value with no semantic meaning. Will be included in the payload verbatim. May be used to track mutations by the client.',
            type: GraphQLString
          }
        }, TableInput ? (0, _defineProperty2["default"])({}, inflection.tableFieldName(table), {
          description: "The `".concat(tableTypeName, "` to be created by this mutation."),
          type: new GraphQLNonNull(TableInput)
        }) : null)
      }, {
        __origin: "Adding table create input type for ".concat(describePgEntity(table), ". You can rename the table's GraphQL type via a 'Smart Comment':\n\n  ").concat(sqlCommentByAddingTags(table, {
          name: 'newNameHere'
        })),
        isPgCreateInputType: true,
        pgInflection: table,
        // TODO:v5: remove - TYPO!
        pgIntrospection: table
      });
      var PayloadType = newWithHooks(GraphQLObjectType, {
        name: inflection.createPayloadType(table),
        description: "The output of our create `".concat(tableTypeName, "` mutation."),
        fields: function fields(_ref2) {
          var fieldWithHooks = _ref2.fieldWithHooks;
          var tableName = inflection.tableFieldName(table);
          return (0, _defineProperty2["default"])({
            clientMutationId: {
              description: 'The exact same `clientMutationId` that was provided in the mutation input, unchanged and unused. May be used by a client to track mutations.',
              type: GraphQLString
            }
          }, tableName, pgField(build, fieldWithHooks, tableName, {
            description: "The `".concat(tableTypeName, "` that was created by this mutation."),
            type: Table
          }, {
            isPgCreatePayloadResultField: true,
            pgFieldIntrospection: table
          }));
        }
      }, {
        __origin: "Adding table create payload type for ".concat(describePgEntity(table), ". You can rename the table's GraphQL type via a 'Smart Comment':\n\n  ").concat(sqlCommentByAddingTags(table, {
          name: 'newNameHere'
        }), "\n\nor disable the built-in create mutation via:\n\n  ").concat(sqlCommentByAddingTags(table, {
          omit: 'create'
        })),
        isMutationPayload: true,
        isPgCreatePayloadType: true,
        pgIntrospection: table
      });
      var fieldName = inflection.createField(table);
      memo = build.extend(memo, (0, _defineProperty2["default"])({}, fieldName, fieldWithHooks(fieldName, function (context) {
        var getDataFromParsedResolveInfoFragment = context.getDataFromParsedResolveInfoFragment;
        var relevantAttributes = table.attributes.filter(function (attr) {
          return pgColumnFilter(attr, build, context) && !omit(attr, 'create');
        });
        return {
          description: "Creates a single `".concat(tableTypeName, "`."),
          type: PayloadType,
          args: {
            input: {
              type: new GraphQLNonNull(InputType)
            }
          },
          resolve: function resolve(data, args, resolveContext, resolveInfo) {
            return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
              var input, pgClient, parsedResolveInfoFragment, resolveData, insertedRowAlias, query, sqlKeyList, sqlKeys, sqlFullTableName, sqlColumns, sqlValues, inputData, mutationQuery, row, _yield$pgClient$query, _yield$pgClient$query2, result, _query, _sql$compile, text, values, _yield$pgPrepareAndRu, _yield$pgPrepareAndRu2;

              return _regenerator["default"].wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      input = args.input;
                      pgClient = resolveContext.pgClient;
                      parsedResolveInfoFragment = parseResolveInfo(resolveInfo);
                      parsedResolveInfoFragment.args = args; // Allow overriding via makeWrapResolversPlugin

                      resolveData = getDataFromParsedResolveInfoFragment(parsedResolveInfoFragment, PayloadType);
                      insertedRowAlias = sql.identifier(Symbol());
                      query = queryFromResolveData(insertedRowAlias, insertedRowAlias, resolveData, {}, null, resolveContext, resolveInfo.rootValue);
                      sqlKeyList = keyColumns.map(function (key) {
                        return sql.identifier(key.name);
                      });
                      sqlKeys = sql.join(sqlKeyList, ',');
                      sqlFullTableName = sql.identifier(table.namespace.name, table.name);
                      sqlColumns = [];
                      sqlValues = [];
                      inputData = input[inflection.tableFieldName(table)];
                      relevantAttributes.forEach(function (attr) {
                        var fieldName = inflection.column(attr);
                        var val = inputData[fieldName];

                        if (Object.prototype.hasOwnProperty.call(inputData, fieldName)) {
                          sqlColumns.push(sql.identifier(attr.name));
                          sqlValues.push(gql2pg(val, attr.type, attr.typeModifier));
                        }
                      });
                      mutationQuery = sql.query(_templateObject(), sql.identifier(table.namespace.name, table.name), sqlColumns.length ? sql.fragment(_templateObject2(), sql.join(sqlColumns, ', '), sql.join(sqlValues, ', ')) : sql.fragment(_templateObject3()), sqlKeys);
                      _context.prev = 15;
                      _context.next = 18;
                      return pgClient.query('SAVEPOINT graphql_mutation');

                    case 18:
                      _context.next = 20;
                      return pgClient.query(sql.compile(mutationQuery));

                    case 20:
                      _yield$pgClient$query = _context.sent;
                      _yield$pgClient$query2 = (0, _slicedToArray2["default"])(_yield$pgClient$query.rows, 1);
                      result = _yield$pgClient$query2[0];
                      _query = queryFromResolveData(sqlFullTableName, undefined, resolveData, {
                        useAsterisk: false
                      }, function (queryBuilder) {
                        var sqlTableAlias = queryBuilder.getTableAlias();
                        keyColumns.forEach(function (key) {
                          queryBuilder.where(sql.fragment(_templateObject4(), sqlTableAlias, sql.identifier(key.name), gql2pg(result[key.name], key.type, key.typeModifier)));
                        });
                      }, resolveContext, resolveInfo.rootValue);
                      _sql$compile = sql.compile(_query), text = _sql$compile.text, values = _sql$compile.values;
                      _context.next = 27;
                      return pgPrepareAndRun(pgClient, text, values);

                    case 27:
                      _yield$pgPrepareAndRu = _context.sent;
                      _yield$pgPrepareAndRu2 = (0, _slicedToArray2["default"])(_yield$pgPrepareAndRu.rows, 1);
                      row = _yield$pgPrepareAndRu2[0];
                      _context.next = 32;
                      return pgClient.query('RELEASE SAVEPOINT graphql_mutation');

                    case 32:
                      _context.next = 39;
                      break;

                    case 34:
                      _context.prev = 34;
                      _context.t0 = _context["catch"](15);
                      _context.next = 38;
                      return pgClient.query('ROLLBACK TO SAVEPOINT graphql_mutation');

                    case 38:
                      throw _context.t0;

                    case 39:
                      return _context.abrupt("return", {
                        clientMutationId: input.clientMutationId,
                        data: row
                      });

                    case 40:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee, null, [[15, 34]]);
            }))();
          }
        };
      }, {
        pgFieldIntrospection: table,
        isPgCreateMutationField: true
      })), "Adding create mutation for ".concat(describePgEntity(table), ". You can omit this default mutation with a 'Smart Comment':\n\n  ").concat(sqlCommentByAddingTags(table, {
        omit: 'create'
      })));
      return memo;
    }, {}), "Adding default 'create' mutation to root mutation");
  }, ['PgMutationCreate'], [], ['PgTables']);
};

exports["default"] = PgMutationCreatePlugin;